---
title: "FreeBSD 9.0-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2012 The FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD: stable/9/release/doc/en_US.ISO8859-1/relnotes/article.sgml
230006 2012-01-12 05:51:11Z hrs $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>SPARC, SPARC64, SPARCengine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. SPARC International, Inc owns all of the SPARC
trademarks and under licensing agreements allows the proper use of these trademarks by
its members.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN18" name="AEN18"></a>
<p>The release notes for FreeBSD 9.0-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 9.0-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#RELENG">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>

<dd>
<dl>
<dt>3.1 <a href="#AEN1251">Upgrading using freebsd-update(8) or a source-based
procedure</a></dt>

<dt>3.2 <a href="#AEN1267">User-visible incompatibilities</a></dt>

<dd>
<dl>
<dt>3.2.1 <a href="#AEN1272">Update of <tt class="LITERAL">dialog</tt></a></dt>

<dt>3.2.2 <a href="#AEN1277">Partition Metadata Integrity Check</a></dt>

<dt>3.2.3 <a href="#AEN1308">ATA/SATA subsystem now <span
class="CITEREFENTRY">cam(4)</span>-based</a></dt>

<dt>3.2.4 <a href="#AEN1395">Network Configuration Changes in <tt
class="FILENAME">/etc/rc.conf</tt></a></dt>

<dt>3.2.5 <a href="#AEN1613">Openresolv and <tt
class="FILENAME">/etc/resolv.conf</tt></a></dt>

<dt>3.2.6 <a href="#AEN1630">Disk Partition Management Utilities</a></dt>
</dl>
</dd>
</dl>
</dd>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 9.0-RELEASE. It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 9.0-RELEASE is a release distribution. It can be found at
<a href="http://www.FreeBSD.org/releases/"
target="_top">http://www.FreeBSD.org/releases/</a> or any of its mirrors. More
information on obtaining this (or other) release distributions of FreeBSD can be found in
the <a href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 9.0-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
8.2-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
8.2-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have been fixed. For more
information, consult the individual advisories available from <a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="INFORMALTABLE"><a id="AEN38" name="AEN38"></a>
<table border="0" frame="void" width="100%" class="CALSTABLE">
<col width="20%" />
<col width="20%" />
<col width="60%" />
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:01.mountd.asc"
target="_top">SA-11:01.mountd</a></td>
<td>20&nbsp;April&nbsp;2011</td>
<td>
<p>Network ACL mishandling in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mountd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mountd</span>(8)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:02.bind.asc"
target="_top">SA-11:02.bind</a></td>
<td>28&nbsp;May&nbsp;2011</td>
<td>
<p>BIND remote DoS with large RRSIG RRsets and negative caching</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:04.compress.asc"
target="_top">SA-11:04.compress</a></td>
<td>28&nbsp;September&nbsp;2011</td>
<td>
<p>Errors handling corrupt compress file in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=compress&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">compress</span>(1)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gzip&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gzip</span>(1)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:05.unix.asc"
target="_top">SA-11:05.unix</a></td>
<td>28&nbsp;September&nbsp;2011</td>
<td>
<p>Buffer overflow in handling of UNIX socket addresses</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:06.bind.asc"
target="_top">SA-11:06.bind</a></td>
<td>23&nbsp;December&nbsp;2011</td>
<td>
<p>Remote packet Denial of Service against <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a>
servers</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:07.chroot.asc"
target="_top">SA-11:07.chroot</a></td>
<td>23&nbsp;December&nbsp;2011</td>
<td>
<p>Code execution via chrooted ftpd</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:08.telnetd.asc"
target="_top">SA-11:08.telnetd</a></td>
<td>23&nbsp;December&nbsp;2011</td>
<td>
<p>telnetd code execution vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:09.pam_ssh.asc"
target="_top">SA-11:09.pam_ssh</a></td>
<td>23&nbsp;December&nbsp;2011</td>
<td>
<p>pam_ssh improperly grants access when user account has unencrypted SSH private
keys</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-11:10.pam.asc"
target="_top">SA-11:10.pam</a></td>
<td>23&nbsp;December&nbsp;2011</td>
<td>
<p><code class="FUNCTION">pam_start()</code> does not validate service names</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The FreeBSD kernel now supports Capsicum Capability Mode. Capsicum is a set of
features for sandboxing support, using a capability model in which the capabilities are
file descriptors. Two new kernel options <tt class="LITERAL">CAPABILITIES</tt> and <tt
class="LITERAL">CAPABILITY_MODE</tt> have been added to the <tt
class="FILENAME">GENERIC</tt> kernel. For more information about Capsicum, see <a
href="http://www.cl.cam.ac.uk/research/security/capsicum/"
target="_top">http://www.cl.cam.ac.uk/research/security/capsicum/</a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219129"
target="_top">r219129</a>]</p>

<p>[amd64, i386] The FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dtrace&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dtrace</span>(1)</span></a>
framework now supports <tt class="LITERAL">systrace</tt> for system calls of <tt
class="LITERAL">linux32</tt> and <tt class="LITERAL">freebsd32</tt> on FreeBSD/amd64. Two
new <tt class="FILENAME">systrace_linux32</tt> and <tt
class="FILENAME">systrace_freebsd32</tt> kernel modules provide support for tracing
compat system calls in addition to the native system call tracing provided by the <tt
class="FILENAME">systrace</tt> module.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219559"
target="_top">r219559</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219561"
target="_top">r219561</a>]</p>

<p>[amd64, i386, powerpc] The FreeBSD ELF image activator now supports the <tt
class="LITERAL">PT_GNU_STACK</tt> program header. This is disabled by default. New <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables <code class="VARNAME">kern.elf32.nxstack</code> and <code
class="VARNAME">kern.elf64.nxstack</code> allow enabling <tt
class="LITERAL">PT_GNU_STACK</tt> for the specified ABIs (e.g. <tt
class="LITERAL">elf32</tt> for 32-bit ABI).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217152"
target="_top">r217152</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217396"
target="_top">r217396</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hhook&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hhook</span>(9)</span></a> (Helper
Hook) and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">khelp</span>(9)</span></a> (Kernel
Helpers) KPIs have been implemented. These are a kind of superset of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pfil&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pfil</span>(9)</span></a>
framework for more general use in the kernel. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hhook&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hhook</span>(9)</span></a> KPI
provides a way for kernel subsystems to export hook points that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">khelp</span>(9)</span></a> modules
can hook to provide enhanced or new functionality to the kernel. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">khelp</span>(9)</span></a> KPI
provides a framework for managing <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">khelp</span>(9)</span></a>
modules, which indirectly use the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hhook&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hhook</span>(9)</span></a> KPI to
register their hook functions with hook points of interest within the kernel. These allow
a structured way to dynamically extend the kernel at runtime in an ABI preserving
manner.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216758"
target="_top">r216758</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216615"
target="_top">r216615</a>]</p>

<p>[amd64, i386, pc98] A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
tunable <code class="VARNAME">hw.memtest.tests</code> has been added. This controls
whether to perform memory testing at boot time or not. The default value is <tt
class="LITERAL">1</tt> (perform a memory test).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224516"
target="_top">r224516</a>]</p>

<p>A new resource accounting API has been implemented. It can keep per-process, per-jail,
and per-loginclass resource accounting information. Note that this is not built nor
installed by default. To build and install them, specify <tt class="LITERAL">options
RACCT</tt> in the kernel configuration file and rebuild the base system as described in
the <a href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
target="_top">FreeBSD Handbook</a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220137"
target="_top">r220137</a>]</p>

<p>A new resource-limiting API has been implemented. It works in conjunction with the <tt
class="LITERAL">RACCT</tt> resource accounting implementation and takes user-configurable
actions based on the set of rules it maintains and the current resource usage. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rctl</span>(8)</span></a> utility
has been added to manage the rules in userland. Note that this is not built nor installed
by default. To build and install them, specify <tt class="LITERAL">options RCTL</tt> in
the kernel configuration file and rebuild the base system as described in the <a
href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
target="_top">FreeBSD Handbook</a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220163"
target="_top">r220163</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sendmsg&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sendmsg</span>(2)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=recvmsg&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">recvmsg</span>(2)</span></a>
system calls in the FreeBSD Linux ABI compatibility have been improved.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220031"
target="_top">r220031</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=open&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">open</span>(2)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fhopen&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fhopen</span>(2)</span></a> system
calls now support the <tt class="LITERAL">O_CLOEXEC</tt> flag, which allows setting the
<tt class="LITERAL">FD_CLOEXEC</tt> flag for the newly created file descriptor. This is
standardized in IEEE Std 1003.1-2008 (POSIX, Single UNIX Specification Version 4).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219999"
target="_top">r219999</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=posix_fallocate&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">posix_fallocate</span>(2)</span></a> system call has been
implemented. This is a function in POSIX to ensure that a part of the storage for regular
file data is allocated on the file system storage media.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220791"
target="_top">r220791</a>]</p>

<p>Two new system calls <code class="FUNCTION">setloginclass(2)</code> and <code
class="FUNCTION">getloginclass(2)</code> have been added. This makes it possible for the
kernel to track the login class a process is assigned to, which is required for the <tt
class="LITERAL">RCTL</tt> resource limiting framework.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219304"
target="_top">r219304</a>]</p>

<p>[amd64] FreeBSD now supports executing FreeBSD 1/i386 a.out binaries on FreeBSD/amd64.
Note that this is not built nor installed by default. To build and install them, specify
<tt class="LITERAL">options COMPAT_43</tt> in the kernel configuration file and rebuild
the base system as described in the <a
href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
target="_top">FreeBSD Handbook</a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220238"
target="_top">r220238</a>]</p>

<p>The following <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables have been added to show the availability of various kernel features:[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218485"
target="_top">r218485</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219028"
target="_top">r219028</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219029"
target="_top">r219029</a>]</p>

<div class="INFORMALTABLE"><a id="AEN214" name="AEN214"></a>
<table border="0" frame="void" width="100%" class="CALSTABLE">
<col width="25%" />
<col width="75%" />
<thead>
<tr>
<th><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable name</th>
<th>Description</th>
</tr>
</thead>

<tbody>
<tr>
<td><code class="VARNAME">kern.features.ufs_acl</code></td>
<td>ACL (Access Control List) support in UFS</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.ufs_gjournal</code></td>
<td>journaling support through <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gjournal&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gjournal</span>(8)</span></a> for
UFS</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.ufs_quota</code></td>
<td>UFS disk quotas support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.ufs_quota64</code></td>
<td>64-bit UFS disk quotas support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.softupdates</code></td>
<td>FFS soft-updates support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.ffs_snapshot</code></td>
<td>FFS snapshot support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.nfsclient</code></td>
<td>NFS client (old implementation)</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.nfscl</code></td>
<td>NFS client (new implementation)</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.nfsserver</code></td>
<td>NFS server (old implementation)</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.nfsd</code></td>
<td>NFS server (new implementation)</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.kdtrace_hooks</code></td>
<td>Kernel DTrace hooks which are required to load DTrace kernel modules</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.ktr</code></td>
<td>Kernel support for KTR kernel tracing facility</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.ktrace</code></td>
<td>Kernel support for system call tracing</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.hwpmc_hooks</code></td>
<td>Kernel support for HW PMC</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.sysv_msg</code></td>
<td>System V message queues support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.sysv_sem</code></td>
<td>System V semaphores support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.p1003_1b_mqueue</code></td>
<td>POSIX P1003.1B message queues support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.p1003_1b_semaphores</code></td>
<td>POSIX P1003.1B semaphores support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.kposix_priority_scheduling</code></td>
<td>POSIX P1003.1B real-time extensions</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.stack</code></td>
<td>Support for capturing the kernel stack</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.sysv_shm</code></td>
<td>System V shared memory segments support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.pps_sync</code></td>
<td>Support usage of external PPS signal by kernel PLL</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.regression</code></td>
<td>Kernel support for interfaces necessary for regression testing</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.invariant_support</code></td>
<td>Support for modules compiled with the INVARIANTS option</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.zero_copy_sockets</code></td>
<td>Zero copy sockets support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.libmchain</code></td>
<td>mchain library</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.scbus</code></td>
<td>SCSI devices support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.mac</code></td>
<td>Mandatory Access Control Framework support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.audit</code></td>
<td>BSM audit support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_gate</code></td>
<td>GEOM Gate module</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_uzip</code></td>
<td>GEOM uzip read-only compressed disks support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_cache</code></td>
<td>GEOM cache module</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_mirror</code></td>
<td>GEOM mirroring support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_stripe</code></td>
<td>GEOM striping support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_concat</code></td>
<td>GEOM concatenation support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_raid3</code></td>
<td>GEOM RAID-3 functionality</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_fox</code></td>
<td>GEOM FOX redundant path mitigation support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_multipath</code></td>
<td>GEOM multipath support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.g_virstor</code></td>
<td>GEOM virtual storage support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_bde</code></td>
<td>GEOM-based Disk Encryption</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_eli</code></td>
<td>GEOM crypto module</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_journal</code></td>
<td>GEOM journaling support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_shsec</code></td>
<td>GEOM shared secret device support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_vol</code></td>
<td>GEOM support for volume names from UFS superblocks</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_label</code></td>
<td>GEOM labeling support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_sunlabel</code></td>
<td>GEOM Sun/Solaris partitioning support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_bsd</code></td>
<td>GEOM BSD disklabels support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_pc98</code></td>
<td>GEOM NEC PC9800 partitioning support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_linux_lvm</code></td>
<td>GEOM Linux LVM partitioning support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_pc98</code></td>
<td>GEOM partitioning class for PC-9800 disk partitions</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_vtoc8</code></td>
<td>GEOM partitioning class for SMI VTOC8 disk labels</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_bsd</code></td>
<td>GEOM partitioning class for BSD disklabels</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_ebr</code></td>
<td>GEOM partitioning class for extended boot records support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_ebr_compat</code></td>
<td>GEOM EBR partitioning class: backward-compatible partition names</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_gpt</code></td>
<td>GEOM partitioning class for GPT partitions support</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_apm</code></td>
<td>GEOM partitioning class for Apple-style partitions</td>
</tr>

<tr>
<td><code class="VARNAME">kern.features.geom_part_mbr</code></td>
<td>GEOM partitioning class for MBR support</td>
</tr>
</tbody>
</table>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>The default boot loader menu has been updated.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=222417"
target="_top">r222417</a>]</p>

<p>[ia64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> loader
now supports PBVM (Pre-Boot Virtual Memory). This allows linking the kernel at a fixed
virtual address without having to make any assumptions about the physical memory layout.
The PBVM also allows fine control of the address where the kernel and its modules are to
be loaded.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219541"
target="_top">r219541</a>]</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>[powerpc] FreeBSD/powerpc now supports Sony Playstation 3 using the OtherOS feature
available on firmwares 3.15 and earlier.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217044"
target="_top">r217044</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
tunable <code class="VARNAME">machdep.disable_tsc</code> has been added. Setting this to
a non-zero value disables use of TSC (Time Stamp Counter) by turning off boot-time CPU
frequency calibration, DELAY(9) with TSC, and using TSC as a CPU ticker. Another new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
tunable <code class="VARNAME">machdep.disable_tsc_calibration</code> allows to skip the
TSC frequency calibration only. This is useful when one wants to use the nominal
frequency of the chip in Intel processors, for example.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219473"
target="_top">r219473</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220577"
target="_top">r220577</a>]</p>

<p>[amd64, i386] The FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usb&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">usb</span>(4)</span></a> subsystem
now supports USB 3.0 by default.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223098"
target="_top">r223098</a>]</p>

<p>The FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usb&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">usb</span>(4)</span></a> subsystem
now supports USB packet filter. This allows to capture packets which go through each USB
host controller. The implementation is almost based on <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bpf</span>(4)</span></a> code. The
userland program <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usbdump&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">usbdump</span>(8)</span></a> has
been added.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=215649"
target="_top">r215649</a>]</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.1 Network Interface Support</a></h5>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=alc&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">alc</span>(4)</span></a> driver
which could make AR8152-based network interfaces stop working has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217649"
target="_top">r217649</a>]</p>

<p>A bxe(4) driver for Broadcom NetXtreme II 10GbE controllers (BCM57710, BCM57711,
BCM57711E) has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219647"
target="_top">r219647</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgb&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgb</span>(4)</span></a> driver
has been updated to version 7.11.0.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220009"
target="_top">r220009</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgbe&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgbe</span>(4)</span></a> driver
for Chelsio T4 (Terminator 4) based 10Gb/1Gb adapters has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218794"
target="_top">r218794</a>]</p>

<p>[i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dc&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">dc</span>(4)</span></a> driver now
works correctly in kernels with the <code class="OPTION">PAE</code> option.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218832"
target="_top">r218832</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver has been
updated to version 7.3.2.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219753"
target="_top">r219753</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver
has been updated to version 2.2.5.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223350"
target="_top">r223350</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver
now supports Intel I350 PCIe Gigabit Ethernet controllers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218530"
target="_top">r218530</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ixgbe</span>(4)</span></a> driver
has been updated to version 2.3.8.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217593"
target="_top">r217593</a>]</p>

<p>Firmware images in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iwn&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iwn</span>(4)</span></a> driver
for 1000, 5000, 6000, and 6500 series cards have been updated.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220892"
target="_top">r220892</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
has been fixed. It could prevent RX checksum offloading from working.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216860"
target="_top">r216860</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfe&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfe</span>(4)</span></a> driver
which could prevent reinitialization after changing the MTU has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217794"
target="_top">r217794</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ral&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ral</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=run&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">run</span>(4)</span></a> drivers
which could prevent <tt class="LITERAL">hostap</tt> mode from working has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217511"
target="_top">r217511</a>]</p>

<p>A rdcphy(4) driver for RDC Semiconductor R6040 10/100 PHY has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216828"
target="_top">r216828</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports RTL8168E/8111E-VL PCIe Gigabit Ethernet controllers and RTL8401E PCIe Fast
Ethernet controllers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217498"
target="_top">r217498</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218760"
target="_top">r218760</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports TX interrupt moderation on RTL810xE PCIe Fast Ethernet controllers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217766"
target="_top">r217766</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports another mechanism for RX interrupt moderation because of performance problems. A
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">dev.re.<tt
class="REPLACEABLE"><i>N</i></tt>.int_rx_mod</code> has been added to control amount of
time to delay RX interrupt processing, in units of microsecond. Setting it to <tt
class="LITERAL">0</tt> completely disables RX interrupt moderation. A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
tunable <code class="VARNAME">hw.re.intr_filter</code> controls whether the old mechanism
utilizing MSI/MSI-X capability on supported controllers is used or not. When set to a
non-zero value, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver uses the
old mechanism. The default value is <tt class="LITERAL">0</tt> and this tunable has no
effect on controllers without MSI/MSI-X capability.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217902"
target="_top">r217902</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports TSO (TCP Segmentation Offload) on RealTek RTL8168/8111 C or later controllers.
Note that this is disabled by default because broken frames can be sent under certain
conditions.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217246"
target="_top">r217246</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217832"
target="_top">r217832</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports enabling TX and/or RX checksum offloading independently from each other. Note
that TX IP checksum is disabled on some RTL8168C-based network interfaces because it can
generate an incorrect IP checksum when the packet contains IP options.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217381"
target="_top">r217381</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218289"
target="_top">r218289</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver has been
fixed. It could cause a panic when receiving a jumbo frame on an RTL8169C, 8169D, or
8169E controller-based network interface.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217296"
target="_top">r217296</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports RTL8105E PCIe Fast Ethernet controllers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217911"
target="_top">r217911</a>]</p>

<p>The rlphy(4) driver now supports the Realtek RTL8201E 10/100 PHY found in RTL8105E
controllers.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217910"
target="_top">r217910</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sis&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sis</span>(4)</span></a> driver
has been fixed. It could prevent a proper reinitialization on DP83815, DP83816, and SiS
900/7016 controllers when the configuration of multicast packet handling and/or
promiscuous mode is changed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217548"
target="_top">r217548</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a> pseudo
interface han been fixed. It could have a random interface identifier in an automatically
configured IPv6 link-local address, instead of one generated with the parent interface's
IEEE 802 48-bit MAC address and an algorithm described in RFC 4291.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216650"
target="_top">r216650</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vte&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vte</span>(4)</span></a> driver
for RDC R6040 Fast Ethernet controllers, which are commonly found on the Vortex86 System
On a Chip, has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216829"
target="_top">r216829</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vxge&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vxge</span>(4)</span></a> driver
for the Neterion X3100 10GbE Server/Storage adapter has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=221167"
target="_top">r221167</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wpi&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wpi</span>(4)</span></a> driver
has been fixed. It could display the following error messages and result in the device
being unusable:[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216824"
target="_top">r216824</a>]</p>

<pre class="SCREEN">
wpi0: could not map mbuf (error 12)
wpi0: wpi_rx_intr: bus_dmamap_load failed, error 12
</pre>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> now
supports IPv6 in the <tt class="COMMAND">fwd</tt> action.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=225044"
target="_top">r225044</a>]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> now
supports the <tt class="COMMAND">call</tt> and <tt class="COMMAND">return</tt> actions.
Upon the <tt class="COMMAND">call <tt class="REPLACEABLE"><i>number</i></tt></tt> action,
the current rule number is saved in the internal stack and ruleset processing continues
with the first rule numbered <tt class="REPLACEABLE"><i>number</i></tt> or higher. The
<tt class="COMMAND">return</tt> action takes the rule number saved to internal stack by
the latest <tt class="COMMAND">call</tt> action and returns ruleset processing to the
first rule with number greater than that saved number.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223666"
target="_top">r223666</a>]</p>

<p>FreeBSD's <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipsec&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipsec</span>(4)</span></a> support
now uses half of the hash size as the authenticator hash size in Hashed Message
Authentication Mode (HMAC-SHA-256, HMAC-SHA-384, and HMAC-SHA-512) as described in RFC
4868. This was a fixed 96-bit length in prior releases because the implementation was
based on an old Internet draft draft-ietf-ipsec-ciph-sha-256-00. Note that this means
9.0-RELEASE and later are no longer interoperable with the older FreeBSD releases.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218794"
target="_top">r218794</a>]</p>

<p>For Infiniband support, OFED (OpenFabrics Enterprise Distribution) version 1.5.3 has
been imported into the base system. Note that this is not built nor installed by default.
To build and install them, specify <tt class="LITERAL">WITH_OFED=yes</tt> in <tt
class="FILENAME">/etc/src.conf</tt> and rebuild the base system as described in the <a
href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
target="_top">FreeBSD Handbook</a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219820"
target="_top">r219820</a>]</p>

<p>The FreeBSD TCP/IP network stack now supports IPv4 prefixes with /31 as described in
RFC 3021, &#8220;Using 31-Bit Prefixes on IPv4 Point-to-Point Links&#8221;.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=226572"
target="_top">r226572</a>]</p>

<p>A bug in the FreeBSD TCP/IP network stack has been fixed. Source address selection
could not be performed when multicast options were present but without an interface being
specified.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217169"
target="_top">r217169</a>]</p>

<p>A bug in the <tt class="LITERAL">IPV6_PKTINFO</tt> option used in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sendmsg&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sendmsg</span>(2)</span></a> has
been fixed. The <tt class="LITERAL">IPV6_USE_MIN_MTU</tt> state set by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setsockopt&sektion=2&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">setsockopt</span>(2)</span></a>
was ignored.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=225682"
target="_top">r225682</a>]</p>

<p>The FreeBSD TCP/IP network stack now supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mod_cc&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mod_cc</span>(9)</span></a>
pluggable congestion control framework. This allows TCP congestion control algorithms to
be implemented as dynamically loadable kernel modules. The following kernel modules are
available as of 9.0-RELEASE: <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_chd&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cc_chd</span>(4)</span></a> for
the CAIA-Hamilton-Delay algorithm, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_cubic&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cc_cubic</span>(4)</span></a> for
the CUBIC algorithm, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_hd&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cc_hd</span>(4)</span></a> for the
Hamilton-Delay algorithm, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_htcp&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cc_htcp</span>(4)</span></a> for
the H-TCP algorithm, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_newreno&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cc_newreno</span>(4)</span></a>
for the NewReno algorithm, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_vegas&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cc_vegas</span>(4)</span></a> for
the Vegas algorithm. The default algorithm can be set by a new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">net.inet.tcp.cc.algorithm</code>. The value must be set to
one of the names listed by <code class="VARNAME">net.inet.tcp.cc.available</code>, and
<tt class="LITERAL">newreno</tt> is the default set at boot time. For more detail, see
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mod_cc&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mod_cc</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mod_cc&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mod_cc</span>(9)</span></a> manual
pages.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216109"
target="_top">r216109</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216114"
target="_top">r216114</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216115"
target="_top">r216115</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218152"
target="_top">r218152</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218153"
target="_top">r218153</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218155"
target="_top">r218155</a>]</p>

<p>An <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=h_ertt&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">h_ertt</span>(4)</span></a>
(Enhanced Round Trip Time) <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">khelp</span>(9)</span></a> module
has been added. This module allows per-connection, low noise estimates of the
instantaneous RTT in the TCP/IP network stack with a robust implementation even in the
face of delayed acknowledgments and/or TSO (TCP Segmentation Offload) being in use for a
connection.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217806"
target="_top">r217806</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcp&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tcp</span>(4)</span></a> socket
option <tt class="LITERAL">TCP_CONGESTION</tt> has been added. This allows to select or
query the congestion control algorithm that the TCP/IP network stack will use for
connections on the socket.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218912"
target="_top">r218912</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_ipfw&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_ipfw</span>(4)</span></a> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netgraph</span>(4)</span></a> node
now supports IPv6.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=225586"
target="_top">r225586</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_one2many&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_one2many</span>(4)</span></a>
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netgraph</span>(4)</span></a> node
now supports the <tt class="LITERAL">XMIT_FAILOVER</tt> transmit algorithm. This makes
packets deliver out of the first active <tt class="LITERAL">many</tt> hook.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219127"
target="_top">r219127</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_netflow</span>(4)</span></a> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netgraph</span>(4)</span></a> node
now supports NetFlow version 9. A new <tt class="LITERAL">export9</tt> hook has been
added for NetFlow v9 data. Note that data export can be done simultaneously in both
version 5 and version 9.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219183"
target="_top">r219183</a>]</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ada&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ada</span>(4)</span></a> driver
now supports write cache control. A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">kern.cam.ada.write_cache</code> determines whether the
write cache of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ada&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ada</span>(4)</span></a> devices
is enabled or not. Setting to <tt class="LITERAL">1</tt> enables and <tt
class="LITERAL">0</tt> disables the write cache, and <tt class="LITERAL">-1</tt> leaves
the device default behavior. <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables <code class="VARNAME">kern.cam.ada.<tt
class="REPLACEABLE"><i>N</i></tt>.write_cache</code> can override the configuration in a
per-device basis (the default value is <tt class="LITERAL">-1</tt>, which means to use
the global setting). Note that the value can be changed at runtime, but it takes effect
only after a device reset.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220412"
target="_top">r220412</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arcmsr&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arcmsr</span>(4)</span></a> driver
has been updated to version 1.20.00.22.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224905"
target="_top">r224905</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a> subsystem
now supports the descriptor format sense data of the SPC-3 (SCSI Primary Commands 3)
specification.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=226067"
target="_top">r226067</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom_map&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geom_map</span>(4)</span></a> GEOM
class has been added. This allows to generate multiple geom providers based on a
hard-coded layout of a device with no explicit partition table such as embedded flash
storage. For more information, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom_map&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geom_map</span>(4)</span></a>
manual page.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220559"
target="_top">r220559</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> GEOM
class now supports the following aliases for the MBR and EBR schemes: <tt
class="LITERAL">fat32</tt>, <tt class="LITERAL">ebr</tt>, <tt
class="LITERAL">linux-data</tt>, <tt class="LITERAL">linux-raid</tt>, and <tt
class="LITERAL">linux-swap</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218014"
target="_top">r218014</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> GEOM
class now supports <tt class="LITERAL">bios-boot</tt> GUID for the GPT scheme which is
used in GRUB 2 loader.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218014"
target="_top">r218014</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=graid&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">graid</span>(8)</span></a> GEOM
class has been added. This is a replacement of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>
driver supporting various BIOS-based software RAID.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219974"
target="_top">r219974</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">kern.geom.confxml</code> now contains information about
disk identification in an <tt class="SGMLTAG">&#60;ident&#62;</tt> tag and disk model
strings in a <tt class="SGMLTAG">&#60;descr&#62;</tt> tag.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219056"
target="_top">r219056</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=md&sektion=4&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">md</span>(4)</span></a> memory-backed
pseudo disk device driver now supports a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">vm.md_malloc_wait</code> to specify whether a
malloc-backed disk will use <code class="VARNAME">M_WAITOK</code> or <code
class="VARNAME">M_NOWAIT</code> for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=malloc&sektion=9&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">malloc</span>(9)</span></a> calls.
The <code class="VARNAME">M_WAITOK</code> setting can prevent memory allocation failure
under high load. If it is set to <tt class="LITERAL">0</tt>, a malloc-backed disk uses
<code class="VARNAME">M_NOWAIT</code> for memory allocation. The default value is <tt
class="LITERAL">0</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216793"
target="_top">r216793</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmc&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmc</span>(4)</span></a> driver
that could cause device detection to fail has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216941"
target="_top">r216941</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217509"
target="_top">r217509</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mxge</span>(4)</span></a> driver
has been updated.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223958"
target="_top">r223958</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tws&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tws</span>(4)</span></a> driver
for 3ware 9750 SATA+SAS 6Gb/s RAID controllers has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=226115"
target="_top">r226115</a>]</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>The FreeBSD Fast File System now supports softupdates journaling. It introduces a
intent log into a softupdates-enabled file system which eliminates the need for
background <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> even on
unclean shutdown. This can be enabled in a per-filesystem basis by using the <code
class="OPTION">-j</code> flag of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
or the <code class="OPTION">-j enable</code> option of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tunefs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tunefs</span>(8)</span></a>
utility. Note that the 9.0-RELEASE installer automatically enables softupdates journaling
for newly-created UFS file systems.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=207141"
target="_top">r207141</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218726"
target="_top">r218726</a>]</p>

<p>The FreeBSD Fast File System now supports the <tt class="LITERAL">TRIM</tt> command
when freeing data blocks. A new flag <code class="OPTION">-t</code> in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tunefs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tunefs</span>(8)</span></a>
utilities sets the TRIM-enable flag for a file system. The TRIM-enable flag makes the
file system send a delete request to the underlying device for each freed block. The <tt
class="LITERAL">TRIM</tt> command is specified as a Data Set Management Command in the
ATA8-ACS2 standard to carry the information related to deleted data blocks to a device,
especially for a SSD (Solid-State Drive) for optimization.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216796"
target="_top">r216796</a>]</p>

<p>A new flag <code class="OPTION">-E</code> has been added to the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck_ffs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck_ffs</span>(8)</span></a>
utilities. This clears unallocated blocks, notifying the underlying device that they are
not used and that their contents may be discarded. This is useful in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck_ffs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck_ffs</span>(8)</span></a> for
file systems which have been mounted on systems without <tt class="LITERAL">TRIM</tt>
support, or with <tt class="LITERAL">TRIM</tt> support disabled, as well as filesystems
which have been copied from one device to another.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=221233"
target="_top">r221233</a>]</p>

<p>The FreeBSD NFS subsystem has been updated. The new implementation supports NFS
version 4 in addition to 2 and 3. The kernel options for the NFS server and client are
changed from <tt class="LITERAL">NFSSERVER</tt> and <tt class="LITERAL">NFSCLIENT</tt> to
<tt class="LITERAL">NFSD</tt> and <tt class="LITERAL">NFSCL</tt>. <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables which start with <code class="VARNAME">vfs.nfssrv.</code> have been renamed to
<code class="VARNAME">vfs.nfsd.</code>. The NFS server now supports <code
class="VARNAME">vfs.nfsd.server_max_nfsvers</code> and <code
class="VARNAME">vfs.nfsd.server_min_nfsvers</code> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables to specify the maximum and the minimum NFS version number which the server
accepts. The default value is set to <tt class="LITERAL">3</tt> and <tt
class="LITERAL">2</tt>, respectively.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=221124"
target="_top">r221124</a>]</p>

<p>To enable NFSv4, the following variables are needed on the server side in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a>:</p>

<pre class="PROGRAMLISTING">
nfsv_server_enable="YES"
nfsv4_server_enable="YES"
nfsuserd_enable="YES"
</pre>

<p>and the following line is needed in <tt class="FILENAME">/etc/exports</tt>:</p>

<pre class="PROGRAMLISTING">
V4: /
</pre>

<p>For more information about NFSv4 and its configuration, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfsv4&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfsv4</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=exports&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">exports</span>(5)</span></a>
manual pages.</p>

<p>The FreeBSD NFS subsystem now supports a <code class="OPTION">nocto</code> mount
option. This disables the close-to-open cache coherency check at open time. This option
may improve performance for read-only mounts, but should only be used only if the data on
the server changes rarely. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_nfs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_nfs</span>(8)</span></a>
utility now also supports this flag keyword.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=221436"
target="_top">r221436</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
tunable <code class="VARNAME">vfs.typenumhash</code> has been added and set to <tt
class="LITERAL">1</tt> by default. This enables to use a hash calculation on the file
system identification number internally used in the kernel. This fixes the &#8220;Stale
NFS file handle&#8221; error on NFS clients when upgrading or rebuilding the kernel on
the NFS server due to unexpected change of these identification number values.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=225537"
target="_top">r225537</a>]</p>

<p>The FreeBSD ZFS subsystem has been updated to the SPA (Storage Pool Allocator, also
known as zpool) version 28. It now supports data deduplication, triple parity RAIDZ
(raidz3), snapshot holds, log device removal, zfs diff, zpool split, zpool import <code
class="OPTION">-F</code>, and read-only zpool import.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219089"
target="_top">r219089</a>]</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>Complex exponential functions <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cexp&sektion=3&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cexp</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cexpf&sektion=3&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cexpf</span>(3)</span></a>, and
cube root function <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cbrtl&sektion=3&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cbrtl</span>(3)</span></a> have
been added to <b class="APPLICATION">libm</b>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219359"
target="_top">r219359</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219571"
target="_top">r219571</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdtar&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsdtar</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpio&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpio</span>(1)</span></a>
utilities are now based on <b class="APPLICATION">libarchive</b> version 2.8.4.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224152"
target="_top">r224152</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224153"
target="_top">r224153</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224154"
target="_top">r224154</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuset&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuset</span>(1)</span></a>
utility now supports a <code class="OPTION">-C</code> flag to create a new cpuset and
assign an existing process into that set, and an <tt class="LITERAL">all</tt> keyword in
the <code class="OPTION">-l <tt class="REPLACEABLE"><i>cpu-list</i></tt></code> option to
specify all CPUs in the system.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217416"
target="_top">r217416</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
utility now uses <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolvconf&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolvconf</span>(8)</span></a> to
manage the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolv.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolv.conf</span>(5)</span></a>
file by default. A <code class="VARNAME">resolvconf_enable</code> variable in <tt
class="FILENAME">/etc/dhclient-enter-hooks</tt> controls the behavior.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219739"
target="_top">r219739</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> utility
which could prevent the <tt class="COMMAND">STAT</tt> FTP command from working properly
has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217505"
target="_top">r217505</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> utility
now supports a <code class="OPTION">-p</code> flag to the <tt class="COMMAND">show</tt>
subcommand. This allows showing providers' names of partitions instead of the partitions'
indexes.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219415"
target="_top">r219415</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hastd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hastd</span>(8)</span></a> utility
now drops <tt class="LITERAL">root</tt> privileges of the worker processes to the <tt
class="LITERAL">hast</tt> user.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218049"
target="_top">r218049</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hastd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hastd</span>(8)</span></a> utility
now supports a <tt class="LITERAL">checksum</tt> keyword to specify the checksum
algorithm in a <tt class="LITERAL">resource</tt> section. As of 9.0-RELEASE, <tt
class="LITERAL">none</tt>, <tt class="LITERAL">sha256</tt>, and <tt
class="LITERAL">crc32</tt> are supported.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219351"
target="_top">r219351</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hastd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hastd</span>(8)</span></a> utility
now supports a <tt class="LITERAL">compression</tt> keyword to specify the compression
algorithm in a <tt class="LITERAL">resource</tt> section. As of 9.0-RELEASE, <tt
class="LITERAL">none</tt>, <tt class="LITERAL">hole</tt> and <tt class="LITERAL">lzf</tt>
are supported.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219354"
target="_top">r219354</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hastd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hastd</span>(8)</span></a> utility
now supports a <tt class="LITERAL">source</tt> keyword to specify the local address to
bind to before connecting the remote <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hastd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hastd</span>(8)</span></a>
daemon.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219818"
target="_top">r219818</a>]</p>

<p>An implementation of <code class="FUNCTION">iconv()</code> API libraries and utilities
which are standardized in Single UNIX Specification has been imported. These are based on
NetBSD's Citrus implementation. Note that these are not built nor installed by default.
To build and install them, specify <tt class="LITERAL">WITH_ICONV=yes</tt> in <tt
class="FILENAME">/etc/src.conf</tt> and rebuild the base system as described in the <a
href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
target="_top">FreeBSD Handbook</a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219019"
target="_top">r219019</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility now supports <tt class="LITERAL">fdx</tt>, <tt class="LITERAL">flow</tt>, <tt
class="LITERAL">hdx</tt>, and <tt class="LITERAL">loop</tt> keywords as aliases of <tt
class="LITERAL">full-duplex</tt>, <tt class="LITERAL">flowcontrol</tt>, <tt
class="LITERAL">half-duplex</tt>, and <tt class="LITERAL">loopback</tt>, respectively.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217013"
target="_top">r217013</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=readline&sektion=3&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">readline</span>(3)</span></a> API
set has been imported into <b class="APPLICATION">libedit</b>. This is based on NetBSD's
implementation and BSD licensed utilities now use it instead of GNU <b
class="APPLICATION">libreadline</b>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220370"
target="_top">r220370</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=makefs&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">makefs</span>(8)</span></a>
utility now supports the ISO 9660 format.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224762"
target="_top">r224762</a>]</p>

<p><b class="APPLICATION">libmd</b> and <b class="APPLICATION">libcrypt</b> now support
the SHA-256 and SHA-512 algorithms.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220496"
target="_top">r220496</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220497"
target="_top">r220497</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility now does not expose the internal scope address representation used in the FreeBSD
kernel, which is derived from KAME IPv6 stack, in the results of <tt
class="COMMAND">netstat -ani</tt> and <tt class="COMMAND">netstat -nr</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217642"
target="_top">r217642</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newsyslog&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newsyslog</span>(8)</span></a>
utility now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xz&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">xz</span>(1)</span></a> compression. An
<tt class="LITERAL">X</tt> flag in the optional field has been added to specify the
compression.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218127"
target="_top">r218127</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_group&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pam_group</span>(8)</span></a>
module now supports <code class="OPTION">ruser</code> and <code
class="OPTION">luser</code> options. The <code class="OPTION">ruser</code> make it accept
or reject based on the supplicant's group membership and this is the default behavior.
The <code class="OPTION">luser</code> checks the target user's group membership instead
of the supplicant's one. If neither option was specified, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_group&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pam_group</span>(8)</span></a>
assumes <code class="OPTION">ruser</code> and issues a warning.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219563"
target="_top">r219563</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=poweroff&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">poweroff</span>(8)</span></a>
utility has been added. This is equivalent to:[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216823"
target="_top">r216823</a>]</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> shutdown -p now
</pre>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> utility
now supports <tt class="COMMAND">iface name <tt class="REPLACEABLE"><i>name</i></tt></tt>
and <tt class="COMMAND">iface description <tt
class="REPLACEABLE"><i>description</i></tt></tt> commands. These have the same
functionalities as the <tt class="LITERAL">name</tt> and <tt
class="LITERAL">description</tt> subcommands of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218397"
target="_top">r218397</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ps</span>(1)</span></a> utility now
supports an <code class="OPTION">-o class</code> option to display the login class
information of each process, and <code class="OPTION">-o usertime</code> and <code
class="OPTION">-o systime</code> options for accumulated system and user CPU time,
respectively.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219307"
target="_top">r219307</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219713"
target="_top">r219713</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtadvd</span>(8)</span></a> daemon
now supports a <tt class="LITERAL">noifprefix</tt> keyword to disable gathering on-link
prefixes from interfaces when no <tt class="LITERAL">addr</tt> keyword is specified. An
entry in <tt class="FILENAME">/etc/rtadvd.conf</tt> with <tt
class="LITERAL">noifprefix</tt> and no <tt class="LITERAL">addr</tt> generates an RA
message with no prefix information option.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=222732"
target="_top">r222732</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtsold&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtsold</span>(8)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtadvd</span>(8)</span></a>
daemons now support the RDNSS and DNSSL options described in RFC 6106, &#8220;IPv6 Router
Advertisement Options for DNS Configuration&#8221;. A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtadvctl</span>(8)</span></a>
utility to control the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtadvd</span>(8)</span></a> daemon
has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=222732"
target="_top">r222732</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224006"
target="_top">r224006</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> runtime
linker now supports shared objects as filters in ELF shared libraries. Both standard and
auxiliary filtering have been supported. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> linker's
processing of a filter defers loading a filtee until a filter symbol is referenced unless
the <code class="VARNAME">LD_LOADFLTR</code> environment variable is defined or a <tt
class="LITERAL">-z loadfltr</tt> option was specified when the filter was created.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216695"
target="_top">r216695</a>]</p>

<p>A race condition in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sed&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sed</span>(1)</span></a> utility
has been fixed. When an <code class="OPTION">-i</code> option is specified, there could
be a short time window with no file with the original file name.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217133"
target="_top">r217133</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sh</span>(1)</span></a> program now
supports <tt class="COMMAND">kill</tt> as a built-in command. This allows specifying <tt
class="LITERAL">%<tt class="REPLACEABLE"><i>job</i></tt></tt> which is equivalent to the
corresponding process group. Note that this built-in command returns the exit status <tt
class="LITERAL">2</tt> instead of <tt class="LITERAL">1</tt> if a fatal error occurs as
other built-in commands do.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=216629"
target="_top">r216629</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sh</span>(1)</span></a> program has
been fixed for POSIX conformance. It could return an incorrect exit status when an <tt
class="COMMAND">exit</tt> command with no parameter is specified in the <tt
class="LITERAL">EXIT trap</tt> handler, which is triggered when the shell terminates. In
trap actions for other signals, an <tt class="COMMAND">exit</tt> command with no
parameter returns an exit status corresponding to the received signal.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217176"
target="_top">r217176</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217472"
target="_top">r217472</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sh</span>(1)</span></a> program has
been fixed. When a foreground job exits on a signal, a message is printed to <tt
class="FILENAME">stdout</tt> about this. The buffer was not flushed after printing which
could result in the message being written to the wrong file if the next command was a
built-in and had <tt class="FILENAME">stdout</tt> redirected.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217557"
target="_top">r217557</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sh</span>(1)</span></a> program now
supports a <code class="OPTION">--</code> flag in <tt class="COMMAND">trap</tt> command
to stop the option processing.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217461"
target="_top">r217461</a>]</p>

<p>The <tt class="LITERAL">%builtin</tt> keyword support in the <code
class="VARNAME">$PATH</code> variable has been removed from the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sh</span>(1)</span></a> program. All
built-in commands are always found before looking up directories in <code
class="VARNAME">$PATH</code>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217206"
target="_top">r217206</a>]</p>

<p>Arithmetic expression handling code in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sh</span>(1)</span></a> program has
been updated by importing code from <b class="APPLICATION">dash</b>. It now supports the
conditional operator (<tt class="LITERAL">?:</tt>) and a bug in evaluation of &amp;&amp;
and || around an arithmetic expression has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218466"
target="_top">r218466</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tftpd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tftpd</span>(8)</span></a> daemon
has been fixed. It had an interoperability issue when transferring a large file.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224536"
target="_top">r224536</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=utmp&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">utmp</span>(5)</span></a> user
accounting database has been replaced by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=utmpx&sektion=3&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">utmpx</span>(3)</span></a>. User
accounting utilities will now use <tt class="FILENAME">utmpx</tt> database files
exclusively. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wtmpcvt&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wtmpcvt</span>(1)</span></a>
utility can be used to convert <tt class="FILENAME">wtmp</tt> files to the new format,
making it possible to read them using the updated utilities.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=202188"
target="_top">r202188</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=utxrm&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">utxrm</span>(8)</span></a> utility
has been added. This allows one to remove an entry from the <tt
class="FILENAME">utmpx</tt> database by hand. This is useful when a login daemon crashes
or fails to remove the entry during shutdown.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218847"
target="_top">r218847</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zpool&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">zpool</span>(8)</span></a>:
utility now supports a <tt class="COMMAND">zpool labelclear</tt> command. This allows to
wipe the label data from a drive that is not active in a pool.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224171"
target="_top">r224171</a>]</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><tt class="LITERAL">ACPI CA</tt> has been updated to version 20110527.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=222544"
target="_top">r222544</a>]</p>

<p>The <b class="APPLICATION">awk</b> has been updated to the 7 August 2011 release.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224731"
target="_top">r224731</a>]</p>

<p><b class="APPLICATION">ISC BIND</b> has been updated to version 9.8.1-P1.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=228189"
target="_top">r228189</a>]</p>

<p><b class="APPLICATION">GNU binutils</b> has been updated to 2.17.50 (as of 3 July
2007), which is the last available version under GPLv2.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218822"
target="_top">r218822</a>]</p>

<p>The <b class="APPLICATION">compiler-rt</b> library, which provides low-level
target-specific interfaces such as functions in <b class="APPLICATION">libgcc</b>, has
been imported.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=222656"
target="_top">r222656</a>]</p>

<p><tt class="LITERAL">dialog</tt> has been updated to version 1.1-20110707.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224014"
target="_top">r224014</a>]</p>

<p>The <tt class="LITERAL">netcat</tt> utility has been updated to version 4.9.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=221793"
target="_top">r221793</a>]</p>

<p>The <b class="APPLICATION">tnftp</b> (formerly known as <b
class="APPLICATION">lukemftp</b>) has been updated to tnftp-20100108.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223328"
target="_top">r223328</a>]</p>

<p><b class="APPLICATION">GNU GCC</b> and <b class="APPLICATION">libstdc++</b> have been
updated to rev 127959 of <tt class="LITERAL">gcc-4_2-branch</tt> (the last GPLv2-licensed
version).[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=220150"
target="_top">r220150</a>]</p>

<p><b class="APPLICATION">gdtoa</b>, a set of binary from/to decimal number conversion
routines used in FreeBSD's <b class="APPLICATION">libc</b> library has been updated to a
snapshot as of 4 March, 2011.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219557"
target="_top">r219557</a>]</p>

<p>The <b class="APPLICATION">LESS</b> program has been updated to version v444.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=222906"
target="_top">r222906</a>]</p>

<p>The <b class="APPLICATION">LLVM</b> compiler infrastructure and <b
class="APPLICATION">clang</b>, a C language family front-end, version 3.0 have been
imported. Note that it is not used for building the FreeBSD base system by default. In
the FreeBSD build infrastructure, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=clang&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">clang</span>(1)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=clang++&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">clang++</span>(1)</span></a>, and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=clang-cpp&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">clang-cpp</span>(1)</span></a>
utilities can be used in <code class="VARNAME">CC</code>, <code
class="VARNAME">CXX</code>, and <code class="VARNAME">CPP</code> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a>
variables, respectively.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=208954"
target="_top">r208954</a>]</p>

<p><b class="APPLICATION">Openresolv</b> version 3.4.4 has been imported. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolvconf&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolvconf</span>(8)</span></a>
utility now manages the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolv.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolv.conf</span>(5)</span></a>
file.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=219734"
target="_top">r219734</a>]</p>

<p>The <b class="APPLICATION">OpenSSH</b> utility has been updated to 5.8p2, and
optimization for large bandwidth-delay product connection and <tt
class="LITERAL">none</tt> cipher support have been merged[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=221484"
target="_top">r221484</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=224638"
target="_top">r224638</a>]</p>

<p>The <b class="APPLICATION">pf</b> packet filter has been updated to version 4.5.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223637"
target="_top">r223637</a>]</p>

<p><b class="APPLICATION">sendmail</b> has been updated to version 8.14.5.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223067"
target="_top">r223067</a>]</p>

<p>The <b class="APPLICATION">timezone</b> database has been updated to the <b
class="APPLICATION">tzdata2011m</b> release.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=226750"
target="_top">r226750</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unifdef&sektion=1&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">unifdef</span>(1)</span></a>
utility has been updated to version 2.5.6.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=217698"
target="_top">r217698</a>]</p>

<p>The <b class="APPLICATION">xz</b> program has been updated from 5.0.0 to a snapshot as
of 11 July, 2011.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=223935"
target="_top">r223935</a>]</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.5 Release Engineering and
Integration</a></h3>

<p>A new installer <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdinstall&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsdinstall</span>(8)</span></a>
has been added and integrated into installation ISO images. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
utility is also available for configuration after the installation.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=218799"
target="_top">r218799</a>]</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde4/pkg-descr"><tt
class="FILENAME">x11/kde4</tt></a>) has been updated from 4.5.5 to 4.7.3.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<div class="SECT2">
<h3 class="SECT2"><a id="AEN1251" name="AEN1251">3.1 Upgrading using freebsd-update(8) or
a source-based procedure</a></h3>

<p>[amd64, i386] Beginning with FreeBSD 6.2-RELEASE, binary upgrades between RELEASE
versions (and snapshots of the various security branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as a unmodified GENERIC
kernel distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded have Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="FILENAME">/usr/src/UPDATING</tt>.</p>

<p>For more specific information about upgrading instructions, see <a
href="http://www.FreeBSD.org/releases/9.0R/installation.html"
target="_top">http://www.FreeBSD.org/releases/9.0R/installation.html</a>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="AEN1267" name="AEN1267">3.2 User-visible
incompatibilities</a></h3>

<p>This section describes notable incompatibilities which you might want to know before
upgrading your system. <span class="emphasis"><i class="EMPHASIS">Please read this
section and the <a href="http://www.FreeBSD.org/releases/9.0R/errata.html"
target="_top">Errata document</a> carefully before submitting a problem report and/or
posting a question to the FreeBSD mailing lists.</i></span></p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN1272" name="AEN1272">3.2.1 Update of <tt
class="LITERAL">dialog</tt></a></h4>

<p>The <tt class="LITERAL">dialog</tt> library is used in FreeBSD's new installer and the
FreeBSD Ports Collection to display a dialog window and allow users to select various
options. Note that it is updated in 9.0-RELEASE and there are several differences in key
operations which might confuse users who are familiar with releases prior to 9.0-RELEASE.
For example, pushing the enter key in a checklist window will no longer check an item.
The new version consistently uses space bar for selecting an item and the enter key for
OK/Cancel selection.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN1277" name="AEN1277">3.2.2 Partition Metadata Integrity
Check</a></h4>

<p>FreeBSD now checks the integrity of partition metadata when a partition table is found
on a disk though the GEOM <b class="APPLICATION">PART</b> subsystem. This detection is
automatically performed when a disk device is ready. The GEOM <b
class="APPLICATION">PART</b> class in the kernel verifies all generic partition
parameters obtained from the disk metadata, and if some inconsistency is detected, the
partition table will be rejected with the following diagnostic message:</p>

<pre class="SCREEN">
GEOM_PART: Integrity check failed
</pre>

<p>This integrity check is enabled by default. On a system prior to 9.0-RELEASE, the
inconsistencies were silently ignored. Therefore, there is a possibility that this
prevents a system from booting after upgrading it to 9.0-RELEASE. More specifically, the
kernel cannot mount the system partition at boot time in some cases.</p>

<p>If this happens, a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
tunable <code class="VARNAME">kern.geom.part.check_integrity</code> can be used as a
workaround. Enter the following lines in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> prompt
at boot time:</p>

<pre class="SCREEN">
<kbd class="USERINPUT">set kern.geom.part.check_integrity="0"</kbd>
<kbd class="USERINPUT">boot</kbd>
</pre>

<p>These commands temporarily disable the integrity check. If it was the cause of the
boot failure, the FreeBSD kernel should detect the partitions as the prior release did,
after entering the commands. This configuration can be added into <tt
class="FILENAME">/boot/loader.conf</tt> as follows:</p>

<pre class="PROGRAMLISTING">
kern.geom.part.check_integrity="0"
</pre>

<p>To check inconsistent metadata after booting on the system, use the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> utility
on the system. A corrupted entry will be displayed like the following:</p>

<pre class="SCREEN">
<samp class="PROMPT">%</samp> gpart show
=&#62;        63  1953525104  mirror/gm0  MBR  (931G) [CORRUPT]
          63  1953525105           1  freebsd  [active]  (931G)
</pre>

<p>For more information, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> manual
page.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN1308" name="AEN1308">3.2.3 ATA/SATA subsystem now <span
class="CITEREFENTRY">cam(4)</span>-based</a></h4>

<p>In 9.0-RELEASE, the FreeBSD ATA/SATA disk subsystem has been replaced with a new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a>-based
implementation. <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a> stands
for Common Access Method, which is an implementation of an API set originally for SCSI-2
and standardized as "SCSI-2 Common Access Method Transport and SCSI Interface Module".
FreeBSD has used the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a> subsystem
to handle SCSI devices since 3.X.</p>

<p>Although the new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a>-based
ATA/SATA subsystem provides various functionality which the old <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> did not
have, it also has some incompatibilities:</p>

<ul>
<li>
<p>An ATA/SATA disk is now recognized as a device node with a name <tt
class="DEVICENAME">ada<tt class="REPLACEABLE"><i>0</i></tt></tt> instead of <tt
class="DEVICENAME">ad<tt class="REPLACEABLE"><i>0</i></tt></tt>. Currently, a symbolic
link <tt class="FILENAME">/dev/ad<tt class="REPLACEABLE"><i>0</i></tt></tt> is
automatically generated for <tt class="FILENAME">/dev/ada<tt
class="REPLACEABLE"><i>0</i></tt></tt> to keep backward compatibility. This symbolic link
generation can be controlled by a <code
class="VARNAME">kern.cam.ada.legacy_aliases</code> (enabled by default). You might want
to update <tt class="FILENAME">/etc/fstab</tt> and/or consider using volume labels (see
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=glabel&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">glabel</span>(8)</span></a> for
more details) for specifying each file system to be mounted.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atacontrol&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atacontrol</span>(8)</span></a>
utility cannot be used for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a>-based
devices. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=camcontrol&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">camcontrol</span>(8)</span></a>
utility is a replacement.</p>
</li>

<li>
<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>
software RAID is now supported by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=graid&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">graid</span>(8)</span></a> GEOM
class. It generates a device node with a name <tt class="FILENAME">/dev/raid/r<tt
class="REPLACEABLE"><i>0</i></tt></tt> if you previously had <tt
class="FILENAME">/dev/ar<tt class="REPLACEABLE"><i>0</i></tt></tt>. Note that this is not
enabled by default. To enable it, enter the following line in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a>
prompt:</p>

<pre class="SCREEN">
set geom_raid_load="YES"
boot
</pre>

<p>or add the following line to <tt class="FILENAME">/boot/loader.conf</tt>:</p>

<pre class="PROGRAMLISTING">
geom_raid_load="YES"
</pre>

<p>and reboot the system. A symbolic link like <tt class="FILENAME">/dev/ar<tt
class="REPLACEABLE"><i>0</i></tt></tt> will NOT be generated for <tt
class="FILENAME">/dev/raid/r<tt class="REPLACEABLE"><i>0</i></tt></tt>. Therefore, if
your system used <tt class="FILENAME">/dev/ar<tt class="REPLACEABLE"><i>0</i></tt></tt>
as the root partition, mounting local file systems will fail because it is renamed to <tt
class="FILENAME">/dev/raid/r<tt class="REPLACEABLE"><i>0</i></tt></tt>. You need to
update <tt class="FILENAME">/etc/fstab</tt> manually in that case.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=burncd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">burncd</span>(8)</span></a>
utility does not work with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a>-based
devices. Use the cdrecord(1) utility in <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/sysutils/cdrtools/pkg-descr"><tt
class="FILENAME">sysutils/cdrtools</tt></a> instead.</p>
</li>
</ul>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN1395" name="AEN1395">3.2.4 Network Configuration Changes in
<tt class="FILENAME">/etc/rc.conf</tt></a></h4>

<p>Although variables in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> are
basically compatible with earlier releases, ones related to network configuration are
changed because of reorganization of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> scripts.</p>

<ul>
<li>
<p>An address configuration now always needs an address family keyword. For example, the
following line</p>

<pre class="PROGRAMLISTING">
ifconfig_em0="192.168.2.1 netmask 255.255.255.0"
</pre>

<p>should be</p>

<pre class="PROGRAMLISTING">
ifconfig_em0="inet 192.168.2.1 netmask 255.255.255.0"
</pre>

<p>Although the old convention is still supported in the existing variables for backward
compatibility, some new variables do not support it.</p>
</li>

<li>
<p>The <code class="VARNAME">ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt>_alias<tt
class="REPLACEABLE"><i>0</i></tt></code> variable now requires an address family keyword
to support non-IPv4 address families. For instance,</p>

<pre class="PROGRAMLISTING">
ifconfig_em0_alias0="192.168.2.10 netmask 255.255.255.255"
</pre>

<p>should be</p>

<pre class="PROGRAMLISTING">
ifconfig_em0_alias0="inet 192.168.2.10 netmask 255.255.255.255"
</pre>

<p>Different address families can coexist like the following:</p>

<pre class="PROGRAMLISTING">
ifconfig_em0_alias0="inet 192.168.2.10 netmask 255.255.255.255"
ifconfig_em0_alias1="inet6 2001:db8:1::1 prefixlen 64"
</pre>

<p>Note that IPv6 alias configurations in <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_alias<tt class="REPLACEABLE"><i>N</i></tt></code> will
be ignored when no <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code> variable is defined because it determines
whether IPv6 functionality is enabled on that interface or not (this variable will be
explained later).</p>
</li>

<li>
<p>All alias and static routing configurations through <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a>
variables will be deactivated when invoking <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+9.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> scripts or the
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=service&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">service</span>(8)</span></a>
command with the <tt class="LITERAL">stop</tt> keyword.</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> service netif stop em0
</pre>

<p>stops the interface <tt class="LITERAL">em0</tt>.</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> service routing stop
</pre>

<p>deactivates all static route configurations.</p>

<p>Releases prior to FreeBSD 9.0-RELEASE did not support this functionality properly for
non-IPv4 protocols.</p>
</li>

<li>
<p>IPv6 configuration handling has been changed in the following way. Before in-depth
explanations, here is a before-and-after example. What was previously:</p>

<pre class="PROGRAMLISTING">
ifconfig_em0="192.168.2.1 netmask 255.255.255.0"
ifconfig_em0_alias0="192.168.2.2 netmask 255.255.255.255"

ipv6_enable="YES"
ipv6_ifconfig_em0="2001:db8:1::1 prefixlen 64"
ipv6_ifconfig_em0_alias0="2001:db8:2::1 prefixlen 64"
# em1 uses SLAAC for IPv6 address configuration
</pre>

<p>should be in 9.0-RELEASE:</p>

<pre class="PROGRAMLISTING">
ifconfig_em0="inet 192.168.2.1 netmask 255.255.255.0"
ifconfig_em0_ipv6="inet6 2001:db8:1::1 prefixlen 64 accept_rtadv"
ifconfig_em0_alias0="inet 192.168.2.2 netmask 255.255.255.255"
ifconfig_em0_alias1="inet6 2001:db8:2::1 prefixlen 64"

ifconfig_em1_ipv6="inet6 accept_rtadv"
</pre>

<p>More specific explanations of the changes are as follows:</p>

<ul>
<li>
<p>The <code class="VARNAME">ipv6_enable</code> variable is deprecated. IPv6
functionality on the system is enabled by default. No IPv6 communication will happen if
you configure no IPv6 address.</p>

<p>9.0-RELEASE now supports intermediate configurations between a host and a router IPv6
node. The <code class="VARNAME">ipv6_enable</code> variable assumed that the system was a
host node when <code class="VARNAME">ipv6_gateway_enable</code> was set to <tt
class="LITERAL">NO</tt> (default), and a router node if not. A host node always accepted
ICMPv6 Router Advertise messages, and a router did not.</p>

<p>In 9.0-RELEASE, this model is still applied but on a per-interface basis, not a
system-wide basis. Specifically, if an interface has an <tt
class="LITERAL">ACCEPT_RTADV</tt> flag, RA messages will be accepted on that interface
for SLAAC (StateLess Address AutoConfiguration) regardless of whether the packet
forwarding is enabled or not.</p>

<p>In addition to them, a per-interface flag <tt class="LITERAL">NO_RADR</tt> and a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">net.inet6.ip6.rfc6204w3</code> have been added. This
controls whether default router list information via RA messages on an RA-accepting
interface should be ignored or not. In an IPv6 router model, it is not supposed to accept
RA messages as an information source for the default router list. Because of that,
FreeBSD 9.0-RELEASE ignores the default router list part when IPv6 packet forwarding is
enabled, even if the interface has an <tt class="LITERAL">ACCEPT_RTADV</tt> flag.
However, this can make for a difficult situation when the system has to work as a CPE
(Customer Premises Equipment) which needs RA messages from the upstream network for
network configuration and acts as a router for the LAN simultaneously. For more
information about this kind of configuration, see RFC 6204.</p>

<p>To support this kind of configuration, the <code class="VARNAME">ipv6_cpe_wanif</code>
variable in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> can
be used.</p>

<pre class="PROGRAMLISTING">
ipv6_gateway_enable="YES"
ipv6_cpe_wanif="em0"
</pre>

<p>means the <tt class="LITERAL">em0</tt> interface accepts RA messages and the default
router information in them, and the other interfaces ignore the default router
information part even when the <tt class="LITERAL">ACCEPT_RTADV</tt> flag is set on
them.</p>

<p><code class="VARNAME">ipv6_cpe_wanif</code> handling internally sets the <code
class="VARNAME">net.inet6.ip6.rfc6204w3</code> and the <code
class="VARNAME">net.inet6.ip6.no_radr</code> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variables to <tt class="LITERAL">1</tt>. Note that both are set to <tt
class="LITERAL">0</tt> by default. When the former is set to <tt class="LITERAL">1</tt>,
FreeBSD accepts the default router list even when IPv6 packet forwarding is enabled. Note
that a system administrator needs to set a <tt class="LITERAL">NO_RADR</tt> flag on the
other RA-accepting interfaces, if any, to prevent it from accepting unexpected default
router information. The latter variable means the <tt class="LITERAL">NO_RADR</tt> flag
is automatically set on them.</p>

<p>If <tt class="LITERAL">ipv6_enable="YES"</tt> is defined in FreeBSD 9.0-RELEASE, it
sets <tt class="LITERAL">ipv6_activate_all_interfaces="YES"</tt> in <tt
class="FILENAME">/etc/rc.conf</tt> and the <tt class="LITERAL">inet6 accept_rtadv</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
option on all network interfaces. Note that this is only for backward compatibility. The
<code class="VARNAME">ipv6_enable</code> should not be used in FreeBSD 9.0-RELEASE.</p>
</li>

<li>
<p>The <code class="VARNAME">ipv6_ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt></code>
variable is renamed to <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code>. This variable controls whether IPv6
functionality should be enabled on that interface or not. If <code
class="VARNAME">ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt>_ipv6</code>, is not set,
there is no IPv6 functionality on the interface <tt
class="REPLACEABLE"><i>IF</i></tt>.</p>

<p>Note that the <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code> variable always needs the address family
keyword <tt class="LITERAL">inet6</tt>. If you need an automatic link-local address only,
the following line is enough:</p>

<pre class="PROGRAMLISTING">
ifconfig_em0_ipv6="inet6 auto_linklocal"
</pre>

<p>If you need full-blown IPv6 functionality on all interfaces like prior releases with
<tt class="LITERAL">ipv6_enable="YES"</tt>, including ones with no <code
class="VARNAME">ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt>_ipv6 line</code>, you
might want to use the <code class="VARNAME">ipv6_activate_all_interfaces</code> variable
as explained later.</p>

<p>If <tt class="LITERAL">ipv6_ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt>="..."</tt>
is defined in FreeBSD 9.0-RELEASE, it means <tt class="LITERAL">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6="inet6 ..."</tt>. Note that this is only for
backward compatibility. The <tt class="LITERAL">inet6</tt> address family keyword is
required for <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code>, but was NOT required for <code
class="VARNAME">ipv6_ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt></code>. The <code
class="VARNAME">ipv6_ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt></code> variables
should not be used in 9.0-RELEASE.</p>
</li>

<li>
<p>An interface with no corresponding <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code> variable is marked with an <tt
class="LITERAL">IFDISABLED</tt> flag by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devd&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devd</span>(8)</span></a> daemon.
This flag means IPv6 communication is disabled on that interface. This can also be found
in output of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>:</p>

<pre class="SCREEN">
<samp class="PROMPT">%</samp> ifconfig em0
em0: flags=8843&lt;UP,BROADCAST,RUNNING,SIMPLEX,MULTICAST&gt; metric 0 mtu 1500
        options=9b&lt;RXCSUM,TXCSUM,VLAN_MTU,VLAN_HWTAGGING,VLAN_HWCSUM&gt;
        ether xx:xx:xx:xx:xx:xx
        inet 192.168.2.1 netmask 0xffffff00 broadcast 192.168.2.255
        nd6 options=3&lt;PERFORMNUD,IFDISABLED,ACCEPT_RTADV&gt;
        media: Ethernet autoselect (1000baseT &lt;full-duplex&gt;)
        status: active
</pre>

<p>To enable IPv6 functionality, this flag should be removed first. There are several
ways to do so. Adding an IPv6 address automatically removes this flag. It is possible to
remove this flag explicitly by using the following command:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> ifconfig em0 inet6 -ifdisabled
</pre>

<p>Note that defining an <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code> is the most reasonable way to activate
IPv6 functionality on that interface. This <tt class="LITERAL">IFDISABLED</tt> flag is to
prevent unintended IPv6 communications in an IPv4-only environment even when the
interface has an IPv6 link-local address. If you need full-blown IPv6 functionality on
all interfaces, you might want to use the <code
class="VARNAME">ipv6_activate_all_interfaces</code> variable as explained later.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">net.inet6.ip6.accept_rtadv</code> has been changed. It was
a system-wide configuration knob which controlled whether the system accepts ICMPv6
Router Advertisement messages or not. In FreeBSD 9.0-RELEASE, this knob is converted into
a per-interface <tt class="LITERAL">inet6 accept_rtadv</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
option. Although the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable is available still in FreeBSD 9.0-RELEASE, it now controls whether the
per-interface option is set by default or not. The default value is <tt
class="LITERAL">0</tt> (not accept the RA messages).</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">net.inet6.ip6.auto_linklocal</code> has been changed. It
was a system-wide configuration knob which controlled whether an IPv6 link-local address
was generated on a network interface when it became up. In FreeBSD 9.0-RELEASE, this knob
is converted into a per-interface <tt class="LITERAL">inet6 auto_linklocal</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
option. Although the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable is still available in FreeBSD 9.0-RELEASE, it now controls whether the
per-interface option is set by default or not. The default value is <tt
class="LITERAL">1</tt> (generate a link-local automatically).</p>
</li>

<li>
<p>The functionality of <code class="VARNAME">ipv6_ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_alias<tt class="REPLACEABLE"><i>0</i></tt></code> is
integrated into <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_alias<tt class="REPLACEABLE"><i>0</i></tt></code>.
Note that address family keywords are always required:</p>

<pre class="PROGRAMLISTING">
ifconfig_em0_alias0="inet 192.168.2.10 netmask 255.255.255.255"
ifconfig_em0_alias1="inet6 2001:db8:1::1 prefixlen 64
</pre>

<p>Although <code class="VARNAME">ipv6_ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_alias<tt class="REPLACEABLE"><i>N</i></tt></code> is
still usable in FreeBSD 9.0-RELEASE, it is only for backward compatibility.</p>
</li>

<li>
<p>A new <code class="VARNAME">ipv6_activate_all_interfaces</code> variable has been
added. If this variable is set to <tt class="LITERAL">YES</tt>, the <tt
class="LITERAL">IFDISABLED</tt> option will not be added even if <code
class="VARNAME">ifconfig_<tt class="REPLACEABLE"><i>IF</i></tt>_ipv6</code> variables are
not defined. This can prevent <tt class="LITERAL">IFDISABLED</tt> on dynamically-added
interfaces such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_iface&sektion=4&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_iface</span>(4)</span></a>
where defining <code class="VARNAME">ifconfig_<tt
class="REPLACEABLE"><i>IF</i></tt>_ipv6</code> in advance is difficult.</p>
</li>
</ul>
</li>
</ul>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN1613" name="AEN1613">3.2.5 Openresolv and <tt
class="FILENAME">/etc/resolv.conf</tt></a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolvconf&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolvconf</span>(8)</span></a>
utility has been added and it now handles updating the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolv.conf&sektion=5&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolv.conf</span>(5)</span></a>
file. Direct modifications to <tt class="FILENAME">/etc/resolv.conf</tt> can be
overwritten by network configuration utilities such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtsold&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtsold</span>(8)</span></a>.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN1630" name="AEN1630">3.2.6 Disk Partition Management
Utilities</a></h4>

<p>In earlier releases various utilities were available to manage disk partition
information. They are deprecated in favor of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a>
utility. Specifically, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdisk&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdisk</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=disklabel&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">disklabel</span>(8)</span></a> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdlabel&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsdlabel</span>(8)</span></a>, and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sunlabel&sektion=8&manpath=FreeBSD+9.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sunlabel</span>(8)</span></a>
utilities are no longer supported actively though these are still available for backward
compatibility.</p>
</div>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a
href="http://www.FreeBSD.org/releases/">http://www.FreeBSD.org/releases/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>All users of FreeBSD 9.0-STABLE should subscribe to the &#60;<a
href="mailto:stable@FreeBSD.org">stable@FreeBSD.org</a>&#62; mailing list.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


